diff --git a/test/unit/daemon/bounded_command_test.rb b/test/unit/daemon/bounded_command_test.rb
new file mode 100644
index 00000000..05b07f31
--- /dev/null
+++ b/test/unit/daemon/bounded_command_test.rb
@@ -0,0 +1,58 @@
+require "test_helper"
+require "rbconfig"
+require "hive/daemon/bounded_command"
+
+class BoundedCommandTest < Minitest::Test
+  include HiveTestHelper
+
+  def test_noisy_timed_command_is_capped_while_it_runs
+    with_tmp_dir do |dir|
+      script = File.join(dir, "noisy.rb")
+      File.write(script, <<~RUBY)
+        STDOUT.sync = true
+        STDERR.sync = true
+        loop do
+          STDOUT.write("o" * 16_384)
+          STDERR.write("e" * 16_384)
+        end
+      RUBY
+
+      result = Hive::Daemon::BoundedCommand.capture(
+        env: {},
+        argv: [ RbConfig.ruby, script ],
+        chdir: dir,
+        timeout_sec: 0.1,
+        max_bytes: 1024
+      )
+
+      assert result.timed_out
+      assert_equal 1024, result.stdout.bytesize
+      assert_equal 1024, result.stderr.bytesize
+      assert_empty Dir.glob(File.join(dir, "hive-command-*"))
+    end
+  end
+
+  def test_leader_exit_is_not_held_open_by_descendant_output_handles
+    with_tmp_dir do |dir|
+      script = File.join(dir, "orphan.rb")
+      File.write(script, <<~RUBY)
+        spawn(#{RbConfig.ruby.inspect}, "-e", "sleep 0.5")
+        STDOUT.write("done")
+      RUBY
+      started = Process.clock_gettime(Process::CLOCK_MONOTONIC)
+
+      result = Hive::Daemon::BoundedCommand.capture(
+        env: {},
+        argv: [ RbConfig.ruby, script ],
+        chdir: dir,
+        timeout_sec: 1,
+        max_bytes: 1024
+      )
+
+      elapsed = Process.clock_gettime(Process::CLOCK_MONOTONIC) - started
+      assert result.status.success?
+      assert_equal "done", result.stdout
+      assert_operator elapsed, :<, 1
+    end
+  end
+end
diff --git a/test/unit/daemon/dispatch_request_queue_test.rb b/test/unit/daemon/dispatch_request_queue_test.rb
index a3c6f5e7..1da64fd8 100644
--- a/test/unit/daemon/dispatch_request_queue_test.rb
+++ b/test/unit/daemon/dispatch_request_queue_test.rb
@@ -13,7 +13,7 @@ class HiveDaemonDispatchRequestQueueTest < Minitest::Test
   def write_request(state_home, request_id:, created_at:, argv: [ "hive", "run", "slug-x", "--json" ],
                     project: "hive", slug: "slug-x", requestor: "bot", chat_id: 42,
                     update_id: 99, trigger: "answer_complete", schema_version: Q::SCHEMA_VERSION,
-                    schema: "hive-dispatch-request")
+                    schema: "hive-dispatch-request", expected_cleared_marker_id: nil)
     dir = Q.directory(state_home: state_home)
     filename = Q.filename_for(created_at: created_at, request_id: request_id)
     path = File.join(dir, filename)
@@ -30,6 +30,7 @@ class HiveDaemonDispatchRequestQueueTest < Minitest::Test
       "update_id" => update_id,
       "trigger" => trigger
     }
+    payload["expected_cleared_marker_id"] = expected_cleared_marker_id unless expected_cleared_marker_id.nil?
     File.write(path, JSON.generate(payload))
     path
   end
@@ -55,6 +56,46 @@ class HiveDaemonDispatchRequestQueueTest < Minitest::Test
     end
   end
 
+  def test_guarded_request_round_trips_and_does_not_expire
+    Dir.mktmpdir("hive-dispatch-queue") do |dir|
+      created_at = Time.utc(2026, 5, 28, 18, 0, 0)
+      Q.write_request!(
+        project: "hive", slug: "slug-x",
+        argv: [ "hive", "run", "slug-x" ],
+        requestor: "healer",
+        expected_cleared_marker_id: "marker-1",
+        state_home: dir, now: created_at
+      )
+
+      request = Q.pending(state_home: dir).first
+      assert_equal "marker-1", request.expected_cleared_marker_id
+      refute Q.expired?(request, now: created_at + 86_400)
+    end
+  end
+
+  def test_pending_rejects_invalid_marker_guard
+    Dir.mktmpdir("hive-dispatch-queue") do |dir|
+      write_request(
+        dir, request_id: "BAD", created_at: Time.utc(2026, 5, 28, 18),
+        expected_cleared_marker_id: "../replacement"
+      )
+      reasons = []
+      assert_empty Q.pending(
+        state_home: dir,
+        bad_handler: ->(path:, reason:) { reasons << reason }
+      )
+      assert_equal [ "invalid_expected_cleared_marker_id" ], reasons
+      assert_raises(ArgumentError) do
+        Q.write_request!(
+          project: "hive", slug: "slug-x",
+          argv: [ "hive", "run", "slug-x" ],
+          expected_cleared_marker_id: 123,
+          state_home: dir
+        )
+      end
+    end
+  end
+
   def test_pending_skips_malformed_json_via_bad_handler
     Dir.mktmpdir("hive-dispatch-queue") do |dir|
       good = write_request(dir, request_id: "OK", created_at: Time.utc(2026, 5, 28, 18, 0, 0), slug: "good")
diff --git a/test/unit/daemon/dispatcher_test.rb b/test/unit/daemon/dispatcher_test.rb
index d5de2782..f129e19b 100644
--- a/test/unit/daemon/dispatcher_test.rb
+++ b/test/unit/daemon/dispatcher_test.rb
@@ -210,18 +210,36 @@ class HiveDaemonDispatcherTest < Minitest::Test
     end
   end
 
+  class FakeAutoRetry
+    attr_reader :calls
+
+    def initialize(error: nil)
+      @error = error
+      @calls = []
+    end
+
+    def tick(rows, now:)
+      @calls << { rows: rows, now: now }
+      raise @error if @error
+
+      []
+    end
+  end
+
   # ── construction helpers ───────────────────────────────────────────────
 
   def make_dispatcher(rows: [], dry_run: false, with_merge_watcher: false,
                       with_patrol_scheduler: false, project_enabled: true,
                       dispatch_state: nil, status_result: nil,
                       dispatch_request_state_home: nil, dispatch_result_state_home: nil,
-                      with_digest_scheduler: false, with_answer_digest_scheduler: false)
+                      with_digest_scheduler: false, with_answer_digest_scheduler: false,
+                      auto_retry: FakeAutoRetry.new, auto_retry_enabled: true)
     config = {
       "daemon" => {
         "edit_debounce_sec" => 30,
         "poll_interval_sec" => 30,
-        "shutdown_grace_sec" => 60
+        "shutdown_grace_sec" => 60,
+        "auto_retry" => { "enabled" => auto_retry_enabled }
       }
     }
     controller = Hive::Daemon::ConcurrencyController.new(
@@ -261,7 +279,8 @@ class HiveDaemonDispatcherTest < Minitest::Test
       answer_digest_scheduler: answer_digest_scheduler,
       dry_run: dry_run,
       dispatch_request_state_home: dispatch_request_state_home,
-      dispatch_result_state_home: dispatch_result_state_home
+      dispatch_result_state_home: dispatch_result_state_home,
+      auto_retry: auto_retry
     )
     # Bypass the Hive::Config.find_project / Config.load lookup chain
     # for unit tests — stub the predicate directly.
@@ -279,7 +298,7 @@ class HiveDaemonDispatcherTest < Minitest::Test
     def close; end
   end
 
-  def row(project: "p1", slug: "s1", stage: "1-inbox", marker: "waiting",
+  def row(project: "p1", id: 1, slug: "s1", stage: "1-inbox", marker: "waiting",
           action: "ready_to_brainstorm", command: "hive brainstorm s1",
           mtime: T0 - 600, claude_pid_alive: nil, live_task_lock: nil,
           state_file: nil, folder: nil, marker_attrs: {},
@@ -287,7 +306,7 @@ class HiveDaemonDispatcherTest < Minitest::Test
           blocked: false, workflow: nil)
     folder ||= make_existing_row_folder(project: project, stage: stage, slug: slug)
     Row.new(
-      project: project, slug: slug, stage: stage, workflow: workflow, marker: marker,
+      project: project, id: id, slug: slug, stage: stage, workflow: workflow, marker: marker,
       folder: folder,
       state_file: state_file || File.join(folder, "idea.md"),
       state_file_mtime: mtime, action: action,
@@ -664,6 +683,86 @@ class HiveDaemonDispatcherTest < Minitest::Test
                  "SIGHUP reload must push the reloaded digest config into the scheduler")
   end
 
+  def test_auto_retry_runs_on_status_rows_and_isolated_errors_do_not_stop_dispatch
+    candidate = row(
+      action: "ready_to_plan",
+      command: "hive plan s1 --from 2-brainstorm"
+    )
+    auto_retry = FakeAutoRetry.new(error: RuntimeError.new("probe exploded"))
+    dispatcher, supervisor, _controller, logger = make_dispatcher(
+      rows: [ candidate ], auto_retry: auto_retry
+    )
+
+    dispatcher.tick(now: T0)
+
+    assert_equal [ candidate ], auto_retry.calls.first[:rows]
+    assert_equal 1, supervisor.spawned.length
+    error = logger.events.find { |name, _attrs| name == :auto_retry_error }
+    assert_equal "coordinator_error", error.last[:action]
+    assert_includes error.last[:rationale], "probe exploded"
+  end
+
+  def test_auto_retry_kill_switch_returns_before_coordinator
+    auto_retry = FakeAutoRetry.new
+    dispatcher, = make_dispatcher(
+      rows: [ row ], auto_retry: auto_retry, auto_retry_enabled: false
+    )
+
+    dispatcher.tick(now: T0)
+
+    assert_empty auto_retry.calls
+  end
+
+  def test_auto_retry_receives_only_enabled_nonlegacy_project_rows
+    enabled = row(project: "enabled", slug: "enabled-task")
+    disabled = row(project: "disabled", slug: "disabled-task")
+    legacy = row(project: "legacy", slug: "legacy-task")
+    projects = [
+      Hive::Daemon::StatusConsumer::ProjectInfo.new(
+        name: "enabled", legacy_stage_dirs: []
+      ),
+      Hive::Daemon::StatusConsumer::ProjectInfo.new(
+        name: "disabled", legacy_stage_dirs: []
+      ),
+      Hive::Daemon::StatusConsumer::ProjectInfo.new(
+        name: "legacy", legacy_stage_dirs: [ { "stage_dir" => "1-input" } ]
+      )
+    ]
+    status = Hive::Daemon::StatusConsumer::Result.new(
+      ok: true, rows: [ enabled, disabled, legacy ], projects: projects, error: nil
+    )
+    auto_retry = FakeAutoRetry.new
+    dispatcher, = make_dispatcher(
+      status_result: status, auto_retry: auto_retry
+    )
+    dispatcher.define_singleton_method(:project_enabled?) do |project|
+      project != "disabled"
+    end
+
+    dispatcher.tick(now: T0)
+
+    assert_equal [ enabled ], auto_retry.calls.first[:rows]
+  end
+
+  def test_reload_rebuilds_noninjected_auto_retry_coordinator
+    dispatcher, = make_dispatcher
+    built = []
+    dispatcher.instance_variable_set(:@auto_retry_injected, false)
+    dispatcher.instance_variable_set(
+      :@auto_retry_factory,
+      lambda {
+        instance = FakeAutoRetry.new
+        built << instance
+        instance
+      }
+    )
+
+    dispatcher.send(:reload_config!)
+
+    assert_equal built.last, dispatcher.instance_variable_get(:@auto_retry)
+    assert_equal 1, built.length
+  end
+
   def test_answer_digest_scheduler_dispatches_global_answer_digest_without_project_gate
     dispatcher, sup, _ctrl, logger, _mw, _patrol, _digest, answer_digest = make_dispatcher(
       rows: [],
@@ -2538,7 +2637,7 @@ end
   Q = Hive::Daemon::DispatchRequestQueue
 
   def write_request_file(dir, slug:, request_id:, created_at: T0, argv: nil, project: "p1",
-                         trigger: "answer_complete")
+                         trigger: "answer_complete", expected_cleared_marker_id: nil)
     argv ||= [ "hive", "run", slug, "--json" ]
     path = File.join(Q.directory(state_home: dir), Q.filename_for(created_at: created_at, request_id: request_id))
     payload = {
@@ -2554,14 +2653,22 @@ end
       "update_id" => 99,
       "trigger" => trigger
     }
+    payload["expected_cleared_marker_id"] = expected_cleared_marker_id unless expected_cleared_marker_id.nil?
     File.write(path, JSON.generate(payload))
     path
   end
 
-  def stub_find_project!(dispatcher, project_name)
+  def stub_find_project!(dispatcher, project_name, project_path: "/tmp/nonexistent",
+                         hive_state_path: "/tmp/nonexistent/.hive-state")
     Hive::Config.singleton_class.alias_method(:__orig_find_project, :find_project) unless Hive::Config.singleton_class.method_defined?(:__orig_find_project)
     Hive::Config.define_singleton_method(:find_project) do |name|
-      name == project_name ? { "name" => project_name, "path" => "/tmp/nonexistent", "hive_state_path" => "/tmp/nonexistent/.hive-state" } : nil
+      if name == project_name
+        {
+          "name" => project_name,
+          "path" => project_path,
+          "hive_state_path" => hive_state_path
+        }
+      end
     end
     dispatcher
   end
@@ -3183,6 +3290,123 @@ end
     end
   end
 
+  def test_dispatch_request_blocked_for_legacy_layout_project
+    Dir.mktmpdir("hive-dispatch-queue") do |state_home|
+      project = Hive::Daemon::StatusConsumer::ProjectInfo.new(
+        name: "p1", legacy_stage_dirs: [ { "stage_dir" => "1-input" } ]
+      )
+      status = Hive::Daemon::StatusConsumer::Result.new(
+        ok: true, rows: [], projects: [ project ], error: nil
+      )
+      dispatcher, sup, _ctrl, logger, _mw = make_dispatcher(
+        status_result: status, dispatch_request_state_home: state_home
+      )
+      write_request_file(state_home, slug: "s1", request_id: "LEGACY")
+      stub_find_project!(dispatcher, "p1")
+      begin
+        dispatcher.tick(now: T0)
+
+        blocked = logger.events.find do |name, attrs|
+          name == :dispatch_request_blocked &&
+            attrs[:request_id] == "LEGACY"
+        end
+        assert_equal "legacy_layout_detected", blocked.last[:reason]
+        assert_empty sup.spawned
+        assert_equal 1, Q.pending(state_home: state_home).length
+      ensure
+        restore_find_project!
+      end
+    end
+  end
+
+  def test_guarded_retry_waits_for_exact_marker_clear_then_dispatches
+    Dir.mktmpdir("hive-dispatch-queue") do |state_home|
+      project_root = File.join(state_home, "project")
+      hive_state = File.join(project_root, ".hive-state")
+      folder = File.join(hive_state, "stages", "4-execute", "s1")
+      FileUtils.mkdir_p(folder)
+      state_file = File.join(folder, "task.md")
+      Hive::Markers.set(
+        state_file, :error,
+        reason: "implementer_failed", marker_id: "marker-1"
+      )
+      status_file = File.join(folder, "status.md")
+      File.write(status_file, "# Derived status\n")
+      FileUtils.touch(status_file, mtime: Time.now + 60)
+      dispatcher, sup, _ctrl, logger, _mw = make_dispatcher(
+        rows: [], dispatch_request_state_home: state_home
+      )
+      write_request_file(
+        state_home, slug: "s1", request_id: "GUARDED",
+        argv: [ "hive", "run", "s1", "--project", "p1", "--stage", "4-execute" ],
+        expected_cleared_marker_id: "marker-1"
+      )
+      stub_find_project!(
+        dispatcher, "p1",
+        project_path: project_root, hive_state_path: hive_state
+      )
+      begin
+        dispatcher.tick(now: T0 + Q::EXPIRY_SEC + 1)
+
+        assert_empty sup.spawned
+        assert_equal 1, Q.pending(state_home: state_home).length
+        blocked = logger.events.find do |name, attrs|
+          name == :dispatch_request_blocked &&
+            attrs[:request_id] == "GUARDED"
+        end
+        assert_equal "marker_not_cleared", blocked.last[:reason]
+
+        assert Hive::Markers.clear_current(
+          state_file, expected_name: :error,
+          match_attrs: { "marker_id" => "marker-1" }
+        )
+        dispatcher.tick(now: T0 + Q::EXPIRY_SEC + 2)
+        assert_equal 1, sup.spawned.length
+      ensure
+        restore_find_project!
+      end
+    end
+  end
+
+  def test_guarded_retry_rejects_replacement_terminal_marker
+    Dir.mktmpdir("hive-dispatch-queue") do |state_home|
+      project_root = File.join(state_home, "project")
+      hive_state = File.join(project_root, ".hive-state")
+      folder = File.join(hive_state, "stages", "4-execute", "s1")
+      FileUtils.mkdir_p(folder)
+      state_file = File.join(folder, "task.md")
+      Hive::Markers.set(
+        state_file, :error,
+        reason: "implementer_failed", marker_id: "replacement"
+      )
+      dispatcher, sup, _ctrl, logger, _mw = make_dispatcher(
+        rows: [], dispatch_request_state_home: state_home
+      )
+      write_request_file(
+        state_home, slug: "s1", request_id: "REPLACED",
+        argv: [ "hive", "run", "s1", "--project", "p1", "--stage", "4-execute" ],
+        expected_cleared_marker_id: "marker-1"
+      )
+      stub_find_project!(
+        dispatcher, "p1",
+        project_path: project_root, hive_state_path: hive_state
+      )
+      begin
+        dispatcher.tick(now: T0)
+
+        rejected = logger.events.find do |name, attrs|
+          name == :dispatch_request_rejected &&
+            attrs[:request_id] == "REPLACED"
+        end
+        assert_equal "marker_guard_mismatch", rejected.last[:reason]
+        assert_empty sup.spawned
+        assert_empty Q.pending(state_home: state_home)
+      ensure
+        restore_find_project!
+      end
+    end
+  end
+
   # R-01 from PR #241 ce-code-review: a spawn failure (Errno::EAGAIN
   # under fork-exhaustion, or any other StandardError raised by
   # dispatch_request!) must not abort the rest of the pending queue.
diff --git a/test/unit/daemon/logger_test.rb b/test/unit/daemon/logger_test.rb
index d3dddc1c..8b9ab48f 100644
--- a/test/unit/daemon/logger_test.rb
+++ b/test/unit/daemon/logger_test.rb
@@ -61,6 +61,32 @@ class HiveDaemonLoggerTest < Minitest::Test
     end
   end
 
+  def test_auto_retry_events_accept_structured_identity_and_probe_fields
+    with_log do |logger, path|
+      logger.event(
+        :auto_retry_action,
+        project: "hive",
+        task_slug: "retry-task",
+        stage: "4-execute",
+        marker_id: "marker-1",
+        marker_reason: "implementer_failed",
+        probes: [ { name: "codex_login_status", healthy: true } ],
+        health_fingerprint: "sha256",
+        attempt: 1,
+        action: "retry_queued",
+        rationale: "dependency recovered",
+        timestamp: "2026-07-24T12:00:00Z"
+      )
+      logger.close
+
+      record = JSON.parse(File.read(path))
+      assert_equal "auto_retry_action", record["event"]
+      assert_equal "retry_queued", record["action"]
+      assert_equal true, record.dig("probes", 0, "healthy")
+      assert_equal "sha256", record["health_fingerprint"]
+    end
+  end
+
   # ── closed event enum ─────────────────────────────────────────────────
 
   def test_unknown_event_raises_argument_error
diff --git a/test/unit/daemon/status_consumer_test.rb b/test/unit/daemon/status_consumer_test.rb
index a342b30a..67ed889e 100644
--- a/test/unit/daemon/status_consumer_test.rb
+++ b/test/unit/daemon/status_consumer_test.rb
@@ -38,10 +38,11 @@ class HiveDaemonStatusConsumerTest < Minitest::Test
     }
   end
 
-  def task_row(slug:, stage: "1-inbox", marker: "waiting",
+  def task_row(slug:, id: 7, stage: "1-inbox", marker: "waiting",
                action: "ready_to_brainstorm", command: "hive brainstorm slug",
                mtime: Time.now.utc.iso8601)
     {
+      "id" => id,
       "stage" => stage,
       "slug" => slug,
       "folder" => "/tmp/p/#{stage}/#{slug}",
@@ -74,6 +75,7 @@ class HiveDaemonStatusConsumerTest < Minitest::Test
       assert_equal 1, result.rows.size
       row = result.rows.first
       assert_equal "writero", row.project
+      assert_equal 7, row.id
       assert_equal "fix-bug", row.slug
       assert_equal "ready_to_brainstorm", row.action
       assert_equal "hive brainstorm slug", row.suggested_command
diff --git a/test/unit/events_test.rb b/test/unit/events_test.rb
index 28ac2224..3b220690 100644
--- a/test/unit/events_test.rb
+++ b/test/unit/events_test.rb
@@ -39,6 +39,30 @@ class EventsTest < Minitest::Test
     end
   end
 
+  def test_emit_details_is_optional_and_bounded
+    with_tmp_dir do |dir|
+      legacy = Hive::Events.emit(task_folder: dir, slug: "event-test", stage: "4-execute",
+                                 event_type: :stage_enter)
+      detailed = Hive::Events.emit(
+        task_folder: dir, slug: "event-test", stage: "4-execute",
+        event_type: :auto_retry_decision,
+        details: { action: "parked", attempt: 1 }
+      )
+
+      assert_equal %w[ts slug stage agent event_type message], legacy.keys
+      assert_equal({ "action" => "parked", "attempt" => 1 }, detailed.fetch("details"))
+      assert_raises(ArgumentError) do
+        Hive::Events.emit(task_folder: dir, slug: "event-test", stage: "4-execute",
+                          event_type: :auto_retry_decision, details: "not-an-object")
+      end
+      assert_raises(ArgumentError) do
+        Hive::Events.emit(task_folder: dir, slug: "event-test", stage: "4-execute",
+                          event_type: :auto_retry_decision,
+                          details: { payload: "x" * Hive::Events::MAX_DETAILS_BYTES })
+      end
+    end
+  end
+
   def test_unknown_event_type_raises
     with_tmp_dir do |dir|
       assert_raises(ArgumentError) do
@@ -130,6 +154,27 @@ class EventsTest < Minitest::Test
     end
   end
 
+  def test_emit_required_propagates_append_failures
+    with_tmp_dir do |dir|
+      original_open = File.method(:open)
+      File.define_singleton_method(:open) do |path, *args, **kwargs, &block|
+        if path.to_s.end_with?("events.jsonl")
+          raise Errno::ENOSPC, "events.jsonl"
+        end
+
+        original_open.call(path, *args, **kwargs, &block)
+      end
+      assert_raises(Errno::ENOSPC) do
+        Hive::Events.emit_required(
+          task_folder: dir, slug: "required-event", stage: "4-execute",
+          event_type: :auto_retry_reserved
+        )
+      end
+    ensure
+      File.define_singleton_method(:open, original_open) if original_open
+    end
+  end
+
   def test_concurrent_emits_keep_every_line_parseable
     with_tmp_dir do |dir|
       threads = 5.times.map do |idx|
diff --git a/test/unit/invoked_binary_test.rb b/test/unit/invoked_binary_test.rb
index c259e6d2..23e39fc9 100644
--- a/test/unit/invoked_binary_test.rb
+++ b/test/unit/invoked_binary_test.rb
@@ -92,4 +92,66 @@ class InvokedBinaryTest < Minitest::Test
       end
     end
   end
+
+  def test_loaded_identity_is_stable_and_source_bound
+    first = Hive::InvokedBinary.loaded_identity
+    second = Hive::InvokedBinary.loaded_identity
+
+    assert_equal Hive::VERSION, first.fetch("version")
+    assert_equal first, second
+    assert_match(/\A[0-9a-f]{64}\z/, first.fetch("source_digest"))
+    assert_match(/\A[0-9a-f]{64}\z/, first.fetch("fingerprint"))
+  end
+
+  def test_loaded_identity_is_captured_lazily_and_only_once
+    original = Hive::InvokedBinary.loaded_identity
+    calls = 0
+    Hive::InvokedBinary.instance_variable_set(:@loaded_identity, nil)
+
+    with_replaced_singleton_method(
+      Hive::InvokedBinary, :capture_loaded_identity,
+      lambda {
+        calls += 1
+        { "version" => "test", "source_digest" => "source", "fingerprint" => "fingerprint" }
+      }
+    ) do
+      assert_equal 0, calls
+      assert_equal "fingerprint", Hive::InvokedBinary.loaded_identity.fetch("fingerprint")
+      assert_equal "fingerprint", Hive::InvokedBinary.loaded_identity.fetch("fingerprint")
+      assert_equal 1, calls
+    end
+  ensure
+    Hive::InvokedBinary.instance_variable_set(:@loaded_identity, original.freeze) if original
+  end
+
+  def test_capture_loaded_identity_fails_closed_when_source_cannot_be_resolved
+    with_replaced_singleton_method(
+      File, :realpath, ->(_path) { raise Errno::ENOENT, "source" }
+    ) do
+      identity = Hive::InvokedBinary.capture_loaded_identity(source: "/missing/hive.rb")
+      assert_equal Hive::VERSION, identity.fetch("version")
+      assert_nil identity.fetch("fingerprint")
+    end
+  end
+
+  def test_source_manifest_detects_same_version_component_drift
+    with_tmp_dir do |root|
+      lib = File.join(root, "lib")
+      component = File.join(lib, "hive", "claude_launcher.rb")
+      FileUtils.mkdir_p(File.dirname(component))
+      File.write(File.join(lib, "hive.rb"), "module Hive; VERSION = 'x'; end\n")
+      File.write(component, "OLD = true\n")
+
+      before = Hive::InvokedBinary.capture_loaded_identity(
+        source: File.join(lib, "hive.rb")
+      )
+      File.write(component, "NEW = true\n")
+      after = Hive::InvokedBinary.capture_loaded_identity(
+        source: File.join(lib, "hive.rb")
+      )
+
+      refute_equal before.fetch("source_digest"), after.fetch("source_digest")
+      refute_equal before.fetch("fingerprint"), after.fetch("fingerprint")
+    end
+  end
 end
diff --git a/test/unit/markers_test.rb b/test/unit/markers_test.rb
index 36c743a9..095cf2bd 100644
--- a/test/unit/markers_test.rb
+++ b/test/unit/markers_test.rb
@@ -195,6 +195,25 @@ class MarkersTest < Minitest::Test
     end
   end
 
+  def test_clear_current_rolls_back_when_required_side_effect_fails
+    with_tmp_dir do |dir|
+      file = File.join(dir, "x.md")
+      Hive::Markers.set(file, :error, reason: "boom", marker_id: "marker-1")
+
+      assert_raises(IOError) do
+        Hive::Markers.clear_current(
+          file,
+          expected_name: :error,
+          match_attrs: { "marker_id" => "marker-1" }
+        ) { raise IOError, "audit failed" }
+      end
+
+      marker = Hive::Markers.current(file)
+      assert_equal :error, marker.name
+      assert_equal "marker-1", marker.attrs["marker_id"]
+    end
+  end
+
   def test_set_writes_attrs
     with_tmp_dir do |dir|
       file = File.join(dir, "x.md")
diff --git a/test/unit/stages/execute_test.rb b/test/unit/stages/execute_test.rb
index af52b588..fb947951 100644
--- a/test/unit/stages/execute_test.rb
+++ b/test/unit/stages/execute_test.rb
@@ -149,7 +149,11 @@ class HiveStagesExecuteTest < Minitest::Test
       write_plan(task)
       write_pointer(task, "path" => File.join(dir, "worktree"), "branch" => task.slug, "execute_base_head" => "base")
       git = FakeGit.new(head: "base", branch: task.slug, dirty: false, ancestor_result: true)
-      result = { status: :error, error_message: "exit_code=1 compile error" }
+      result = {
+        status: :error,
+        error_message: "exit_code=1 compile error",
+        log_file: File.join(dir, ".hive-state", "logs", task.slug, "execute-impl-current.log")
+      }
 
       run_result = with_fake_git_and_spawn(git, result: result) do
         Hive::Stages::Execute.run_pass(task, execute_cfg("codex"), File.join(dir, "worktree"))
@@ -161,8 +165,9 @@ class HiveStagesExecuteTest < Minitest::Test
       assert_equal "implementer_failed", marker.attrs["reason"]
       assert_equal "error", marker.attrs["status"]
       assert_equal "exit_code=1 compile error", marker.attrs["message"]
+      assert_equal "codex", marker.attrs["agent"]
+      assert_equal "execute-impl-current.log", marker.attrs["log_file"]
       refute marker.attrs.key?("retry_after")
-      refute marker.attrs.key?("provider")
     end
   end
 
@@ -176,7 +181,11 @@ class HiveStagesExecuteTest < Minitest::Test
       write_plan(task)
       write_pointer(task, "path" => File.join(dir, "worktree"), "branch" => task.slug, "execute_base_head" => "base")
       git = FakeGit.new(head: "base", branch: task.slug, dirty: false, ancestor_result: true)
-      result = { status: :timeout, error_message: "claude stop hook did not signal completion" }
+      result = {
+        status: :timeout,
+        error_message: "claude stop hook did not signal completion",
+        log_file: File.join(dir, ".hive-state", "logs", task.slug, "execute-impl-timeout.log")
+      }
 
       run_result = with_fake_git_and_spawn(git, result: result) do
         Hive::Stages::Execute.run_pass(task, execute_cfg("codex"), File.join(dir, "worktree"))
@@ -188,8 +197,9 @@ class HiveStagesExecuteTest < Minitest::Test
       assert_equal "implementer_failed", marker.attrs["reason"]
       assert_equal "timeout", marker.attrs["status"]
       assert_equal "claude stop hook did not signal completion", marker.attrs["message"]
+      assert_equal "codex", marker.attrs["agent"]
+      assert_equal "execute-impl-timeout.log", marker.attrs["log_file"]
       refute marker.attrs.key?("retry_after")
-      refute marker.attrs.key?("provider")
     end
   end
 
